diff --git a/src/backend/utils/adt/numeric.c b/src/backend/utils/adt/numeric.c
index 0c4fcbe..9d8ffe9 100644
--- a/src/backend/utils/adt/numeric.c
+++ b/src/backend/utils/adt/numeric.c
@@ -6965,10 +6965,22 @@ round_var(NumericVar *var, int rscale)
 
 #if DEC_DIGITS == 1
 			/* di must be zero */
-			carry = (digits[ndigits] >= HALF_NBASE) ? 1 : 0;
+			carry = (digits[ndigits] > HALF_NBASE) ? 1 : 0;
 #else
 			if (di == 0)
-				carry = (digits[ndigits] >= HALF_NBASE) ? 1 : 0;
+			{
+				carry = 0;
+
+				/*
+				 * Set of rules to decide if a digit is carried up using
+				 * nearest-to-even approach.
+				 */
+				if (ndigits == 0)
+					carry = (digits[ndigits] > HALF_NBASE) ? 1 : 0;
+				else if (ndigits > 0 &&
+					digits[ndigits - 1] % 2 == 1)
+					carry = (digits[ndigits] >= HALF_NBASE) ? 1 : 0;
+			}
 			else
 			{
 				/* Must round within last NBASE digit */
